/*
   Test STdecNxxx

   $Id: tSTdecNxxx.c 1.10 2009/03/11 libtsp-v7r0 $
*/

#include <errno.h>
#include <limits.h>
#include <math.h>

#include <libtsp.h>


int
main (int argc, const char *argv[])

{
  int Nmin, Nmax, N;
  const char *String;
  double Dval[100];
  float Fval[100];
  int Ival[100];
  long int Lval[100];
  int status;

  sscanf (argv[2], "%d", &Nmin);
  sscanf (argv[3], "%d", &Nmax);
  String = argv[4];

  if (argv[1][0] == 'D') {
    Dval[0] = sqrt(-1.0);
    status = STdecNdouble (String, Nmin, Nmax, Dval, &N);
    printf (
      "STdecNdouble: input \"%s\", No. vals [%d, ... , %d] -> Error = %d\n",
      String, Nmin, Nmax, status);
    if (N > 0)
      VRdPrint (stdout, "  data values:", Dval, N);
  }
  else if (argv[1][0] == 'F') {
    Fval[0] = sqrt(-1.0);
    status = STdecNfloat (String, Nmin, Nmax, Fval, &N);
    printf (
      "STdecNfloat: input \"%s\", No. vals [%d, ... , %d] -> Error = %d\n",
      String, Nmin, Nmax, status);
    if (N > 0)
      VRfPrint (stdout, "  data values:", Fval, N);
  }
  else if (argv[1][0] == 'I') {
    Ival[0] = INT_MIN;
    status = STdecNint (String, Nmin, Nmax, Ival, &N);
    printf (
      "STdecNint: input \"%s\", No. vals [%d, ... , %d] -> Error = %d\n",
      String, Nmin, Nmax, status);
    if (N > 0)
      VRiPrint (stdout, "  data values:", Ival, N);
  }
  else if (argv[1][0] == 'L') {
    Lval[0] = LONG_MIN;
    status = STdecNlong (String, Nmin, Nmax, Lval, &N);
    printf (
      "STdecNlong: input \"%s\", No. vals [%d, ... , %d] -> Error = %d\n",
      String, Nmin, Nmax, status);
    if (N > 0)
      VRlPrint (stdout, "  data values:", Lval, N);
  }

  return 0;
}
