/*
   Test UTtypes.h

   $Date: 2009/03/11 19:59:36 $
*/

#include <libtsp.h>
#include <libtsp/UTtypes.h>

int
main (int argc, const char *argv[])

{
  int LL, LI, LS, LC, LLL;
  int LD, LF;
  int U8, U4, U2, U1;
  int I8, I4, I2, I1;
  int F8, F4;

  LLL = sizeof (long long int);
  LL = sizeof (long int);
  LI = sizeof (int);
  LS = sizeof (short);
  LC = sizeof (char);
  printf ("sizeof (long long int, long int, int, short int, char): ");
  printf ("%d %d %d %d %d\n", LLL, LL, LI, LS, LC);

  LD = sizeof (double);
  LF = sizeof (float);
  LL = sizeof (long double);
  printf ("sizeof (long double, double, float): %d %d %d\n", LL, LD, LF);

#if defined UT_UINT8_MAX
  U8 = sizeof (UT_uint8_t);
  U4 = sizeof (UT_uint4_t);
  U2 = sizeof (UT_uint2_t);
  U1 = sizeof (UT_uint1_t);
  printf ("sizeof (UT_uint8_t, UT_uint4_t, UT_uint2_t, UT_uint1_t): %d %d %d %d\n",
	  U8, U4, U2, U1);
  if (U8 != 8 || U4 != 4 || U2 != 2 || U1 != 1)
    UThalt ("tUTtypes - Invalid unsigned integer size");
#else
  U4 = sizeof (UT_uint4_t);
  U2 = sizeof (UT_uint2_t);
  U1 = sizeof (UT_uint1_t);
  printf ("sizeof (UT_uint4_t, UT_uint2_t, UT_uint1_t): %d %d %d %d\n",
	  U4, U2, U1);
  if (U4 != 4 || U2 != 2 || U1 != 1)
    UThalt ("tUTtypes - Invalid unsigned integer size");
#endif

#if defined UT_INT8_MAX
  I8 = sizeof (UT_int8_t);
  I4 = sizeof (UT_int4_t);
  I2 = sizeof (UT_int2_t);
  I1 = sizeof (UT_int1_t);
  printf ("sizeof (UT_int8_t, UT_int4_t, UT_int2_t, UT_int1_t): %d %d %d %d\n",
	  I8, I4, I2, I1);
  if (I8 != 8 || I4 != 4 || I2 != 2 || I1 != 1)
    UThalt ("tUTtypes - Invalid integer size");
#else
  I4 = sizeof (UT_int4_t);
  I2 = sizeof (UT_int2_t);
  I1 = sizeof (UT_int1_t);
  printf ("sizeof (UT_int4_t, UT_int2_t, UT_int1_t): %d %d %d\n",
	  I4, I2, I1)
  if (I4 != 4 || I2 != 2 || I1 != 1)
    UThalt ("tUTtypes - Invalid integer size");
#endif

  F8 = sizeof (UT_float8_t);
  F4 = sizeof (UT_float4_t);
  printf ("sizeof (UT_float8_t, UT_float4_t): %d %d\n", F8, F4);
  if (F8 != 8 || F4 != 4)
    UThalt ("tUTtypes - Invalid float size");

  return 0;
}
